// testdrv.cpp: dfinit les fonctions exportes pour l'application DLL.
//

#include "stdafx.h"
#include "stdlib.h"


// Mandatory functions

// Called to connect to the targets
// shall return 0 if success, <0 if error
// params may contains parameters (one parameter per string pointer)
__declspec(dllexport) int ug_connect(LPSTR *params)
{
__try
	{
	return 0;
	}
__except(EXCEPTION_EXECUTE_HANDLER)
	{
	return -1000;
	}
}


// Called to disconnect from target
// shall return 0 if success, <0 if error
__declspec(dllexport) int ug_disconnect(void)
{
__try
	{
	return 0;
	}
__except(EXCEPTION_EXECUTE_HANDLER)
	{
	return -1000;
	}
}



// Called to retrieve variable type
// Shall return <0 if error, 0 is success
// *type shall return the variable type: 
// 1 for bool,
// 2 for int 16 bits,
// 3 for int 32 bits,
// 4 for float (32 bits)
// 5 for float (64 bits)
__declspec(dllexport) int ug_gettype(char *varname, unsigned short *type)
{
return 0;
}



// Called to read a variable
// Shall return <0 if error, 0 is success
// *type shall return the variable type: 
// 1 for bool,
// 2 for int 16 bits,
// 3 for int 32 bits,
// 4 for float (32 bits)
// 5 for float (64 bits)
// result shall return the variable value
// force shall return the force state of the variable: 0=not forced, 1=forced
__declspec(dllexport) int ug_readvar(char *varname, unsigned short *type,unsigned long long *result, unsigned short *force)
{
__try
	{
	 if(type) *type=3; // Entier 32 bits
	*result=atoi(varname);
	return 0;
	}
__except(EXCEPTION_EXECUTE_HANDLER)
	{
	return -1000;
	}
}



// Called to write a variable
// Shall return <0 if error, 0 is success
// *type shall return the variable type: 
// 1 for bool,
// 2 for int 16 bits,
// 3 for int 32 bits,
// 4 for float (32 bits)
// 5 for float (64 bits)
// val is the variable value to be written
// force is the force stat of the variable: 0=not forced, 1=forced
__declspec(dllexport) int ug_writevar(char *varname, unsigned short *type,unsigned long long val, unsigned short force)
{
__try
	{
	return 0;
	}
__except(EXCEPTION_EXECUTE_HANDLER)
	{
	return -1000;
	}
}

// Optional functions

// Called before reading all variables for each variable to be read
// Shall return <0 if error, 0 is success
__declspec(dllexport) int ug_prereadvar(char *varname)
{
return 0;
}

// Called before writing all variables for each variable o be wtitten
// Shall return <0 if error, 0 is success
__declspec(dllexport) int ug_prewritevar(char *varname,unsigned long long val, unsigned short force)
{
return 0;
}


// Called after all ug_prewritevar has been called and before ug_writevar calls
__declspec(dllexport) void ug_beforewrite(void)
{
}

// Called after all ug_prereadvar has been called and before ug_readvar calls
__declspec(dllexport) void ug_beforeread(void)
{
}

// Called after all ug_writevar calls
__declspec(dllexport) void ug_afterewrite(void)
{
}

// Called periodically to check if connection with target is alive
// Shall return <0 if error, 0 is success
__declspec(dllexport) int ug_alive(void)
{
return 0;
}

